unit uFormEditSimSEE;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ComCtrls, maskedit, ExtCtrls, Grids, ucosa, uCosaConNombre, contnrs,
  DifferencesTreeUnit, uFormularioEstatico, uFormularioAutomatico, uInicioYFinal,
  uRegistroDeEditores, uTabsActores;

resourcestring

  rsPosteN = 'Poste Nº';
  rsDuracion = 'Duración';

type

  { TFormEditSimSEE }

  TFormEditSimSEE = class(TFormularioEstatico)
    BAyudaEnganchar: TButton;
    BBuscarArchivoCF: TButton;
    BDefinir_Enganches_SimSEE_Flucar: TButton;
    BEnganches: TButton;
    btAplicarFiltro: TButton;
    btAyudaGlobales: TButton;
    btBuscarCFaux: TButton;
    btCrearNuevoEscenario: TButton;
    btExportarActor_Barra: TButton;
    btImportarActor_Barra: TButton;
    btTodos: TButton;
    btVaciarCFAux: TButton;
    bt_Buscar_Flucar: TButton;
    bt_VaciarCFEnganche: TButton;
    Button1: TButton;
    Button2: TButton;
    CBEstabilizarFrameInicial: TCheckBox;
    cbGenerarRaws: TCheckBox;
    cb_EngancharSala_Escenario: TComboBox;
    eFiltroGeneradores_CO2: TEdit;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label5: TLabel;
    Label51: TLabel;
    Label6: TLabel;
    Label61: TLabel;
    Label91: TLabel;
    LOpt1: TLabel;
    LV_Flucar: TListView;
    LV_Simsee_Flucar: TListView;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    TGlobs_Deterministico: TRadioGroup;
    TGlobs_CAR_CVaR: TRadioGroup;
    TSalaDeJuego_usarArchivoParaInicializarFrameInicial: TRadioGroup;
    TSalaDeJuego_engancharConSala: TRadioGroup;
    TGlobs_SalaMinutal: TRadioGroup;
    rb_fe_promedio: TRadioButton;
    rb_fe_simple: TRadioButton;
    rb_fe_simple_ajustado: TRadioButton;
    rb_VaR: TRadioButton;
    sb_Generadores: TScrollBox;
    tcActores: TTabControl;
    TGLobs_calcular_emisionesco2: TCheckBox;
    TGlobs_FactorEmisiones_ProyectoEolicoSolar: TCheckBox;
    TListGenerador_capa: TEdit;
    TListGenerador_lst: TPanel;
    TListGenerador_nombre: TEdit;
    tsActores: TTabSheet;
    TSalaDeJuego_engancharconsala_escenario: TComboBox;
    TSalaDeJuego_enganchar_promediando_desaparecidas: TCheckBox;
    TSalaDeJuego_estabilizarinicio: TCheckBox;
    ts_CO2: TTabSheet;
    TGlobs_iteracion_flucar_modificar_capacidad: TCheckBox;
    TGlobs_iteracion_flucar_modificar_peaje: TCheckBox;
    TGlobs_iteracion_flucar_modificar_rendimiento: TCheckBox;
    TSalaDeJuego_usarIteradorFlucar: TCheckBox;
    TGlobs_iteracion_flucar_archivo_flucar: TEdit;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    //Label6: TLabel;
    e_archivo_para_enganches:TEdit;
    Panel3: TPanel;
    ts_flucar: TTabSheet;
    TListaEscenarios_lst: TPanel;
    TGlobs_ncronicasopt: TEdit;
    TGlobs_publicarsolovariablesusadasensimres3: TCheckBox;
    TGlobs_semilla_inicial_sim: TEdit;
    Label19: TLabel;
    TGlobs_obligariniciocronicaincierto_1_sim: TCheckBox;
    TGlobs_obligardisponibilidad_1_sim: TCheckBox;
    TGlobs_nmax_iteracionesdelpaso_opt: TEdit;
    TGlobs_semilla_inicial_opt: TEdit;
    TGlobs_nmax_iteracionesdelpaso_sim: TEdit;
    Label18: TLabel;
    TGlobs_SortearOpt: TCheckBox;
    TGlobs_ncronicassim: TEdit;
    TGlobs_NDiscHistoCF: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label10: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label9: TLabel;
    p_usar_car: TPanel;
    TGlobs_car: TEdit;
    TGlobs_obligardisponibilidad_1_opt: TCheckBox;
    TGlobs_problimiteriesgo: TEdit;
    TGlobs_restarutilidadesdelcostofuturo: TCheckBox;
    TGlobs_usar_car: TCheckBox;
    TGlobs_tasadeactualizacion: TEdit;
    ts_simulador: TTabSheet;
    //Label5: TLabel;
    LabelEnganchar1: TLabel;
    p_desde_archivo_cfbin: TPanel;
    rb_enganchar_con_sala: TRadioButton;
    TSalaDeJuego_archivocfaux: TEdit;
    TSalaDeJuego_uniformizar_promediando: TEdit;
    GBInicializarCF: TGroupBox;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    lblEngancheEscenario: TLabel;
    ts_estado: TTabSheet;
    TListFuenteAleatoria_lst: TPanel;
    TListFuenteAleatoria_nombre: TEdit;
    TListFuenteAleatoria_capa: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    TGlobs_DurPaso_minutos: TEdit;
    TGlobs_durPos: TStringGrid;
    TGlobs_EDurPaso: TEdit;
    TGlobs_ENPasosOpt: TEdit;
    TGlobs_ENPasosSim: TEdit;
    TGlobs_fechaFinOpt: TMaskEdit;
    TGlobs_fechaFinSim: TMaskEdit;
    TGlobs_fechaGuardaSim: TMaskEdit;
    TGlobs_fechaIniOpt: TMaskEdit;
    TGlobs_fechaIniSim: TMaskEdit;
    LFechaIni: TLabel;
    gbHorizTiempo: TGroupBox;
    gbPasoTiempo: TGroupBox;
    GroupBox8: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    lblFormatoFecha: TLabel;
    LDurPaso: TLabel;
    LFechaFin: TLabel;
    LNPasosOpt: TLabel;
    LNPasosSim: TLabel;
    LNPostes: TLabel;
    LOpt: TLabel;
    LSim: TLabel;
    MainMenu: TMainMenu;
    Archivo: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    TGlobs_NPostes: TEdit;
    OpenDialog: TOpenDialog;
    pcPrincipal: TPageControl;
    PCPasoDeTiempo: TPageControl;
    TGlobs_PostesMonotonos: TCheckBox;
    tsVariablesGlobales: TTabSheet;
    tsFuentes: TTabSheet;
    TSHorario: TTabSheet;
    TSMinutal: TTabSheet;
    TV_Simsee: TTreeView;
    procedure btCrearNuevoEscenarioClick(Sender: TObject);
    procedure btTodosClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    //procedure rb_desde_archivo_cfbinChange(Sender: TObject);
    procedure tcActoresChange(Sender: TObject);
    procedure TSalaDeJuego_usararchivoparainicializarframeinicialClick(Sender: TObject);
    //procedure rg_HorariaOMinutalClick(Sender: TObject);
  private
    { private declarations }

    // Las listas de los actores que muestra el listado
    ListasDeActoresTabs: array of TListaDeCosasConNombre;

    function AsignarEventosYCargarControlesEstandar(): boolean; override;

    constructor Create(TheOwner: TComponent); override;

    procedure QueryInical; override;
    procedure CargarControlesEspecificos; override;

    procedure SetEvents();override;

    procedure usar_car__OnChange(Sender: TObject);
    procedure SortearOpt__OnChange(Sender: TObject);

  end;

var
  FormEditSimSEE: TFormEditSimSEE;

implementation

{$R *.lfm}

uses
  CosaEditorUnit;

{ TFormEditSimSEE }

procedure TFormEditSimSEE.FormCreate(Sender: TObject);
var
  tabs: TStringList;
begin

  TGlobs_durPos.Cells[0,0]:=rsPosteN;
  TGlobs_durPos.Cells[0,1]:=rsDuracion;

  lblFormatoFecha.Caption := 'Ej.: ' + DateTimeToStr(now());

  RegistrarEditoresActores;
  RegistrarEditoresFuentes;


  tabs:=tabsActores.TabsNames;
  tabs.Add('?');
  tcActores.Tabs := tabs;

end;

procedure TFormEditSimSEE.Label3Click(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.Button1Click(Sender: TObject);
begin
  PrintDataSet(self.dataSet);
end;

procedure TFormEditSimSEE.btTodosClick(Sender: TObject);
begin

end;

procedure TFormEditSimSEE.btCrearNuevoEscenarioClick(Sender: TObject);
begin

end;


procedure TFormEditSimSEE.MenuItem1Click(Sender: TObject);
var
  Select: String;
//  frmChild : TEditorForm;
begin

  Select:='*';
  self.DataSet:=TDataStore.Create(DATA_STORE);
  DATA_STORE.Query(Select, 'dt_TSalaDeJuego', self.DataSet);
  self.DataSet.DataTableList[0].AddDataRow( self.DataSet.DataTableList[0].GetDataRowWithDefaulValues() );


end;

procedure TFormEditSimSEE.MenuItem2Click(Sender: TObject);
var
  filename: string;

  Select: String;
  frmChild : TFormularioAutomatico;
  SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;
  i: Integer;

  btn: TEditorTButtonControl;
  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  dcll: TDataCellOfCosa;
  k: Integer;

begin


  //     --->  Deben ser globales!!!!!  <---
  //COSA_WITH_CUSTOMIZEDFORM_LIST:=TFPHashList.Create();
  //COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaLPD', TFichaLPDForm);
  //COSA_WITH_CUSTOMIZEDFORM_LIST.Add('TFichaGTer_Basico', TFichaGTer_BasicoForm);

  OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if OpenDialog.Execute then
  begin
    filename := OpenDialog.Filename;
    openDialog.Free;

    SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    SalaDeJuegoConnectionHandler.CreateSalaDeJuegoDataStore('sala');

    //ucosa.PrintDataSet(DATA_STORE);

    self.QueryInical;

    for i:=0 to self.ComponentCount-1 do
      WriteLn(self.Components[i].Name);

    AsignarEventosYCargarControlesEstandar;


  end;


end;

procedure TFormEditSimSEE.MenuItem3Click(Sender: TObject);
var
  DTF: TDifferencesTreeForm;
  TreeView:TTreeView;
  filename: String;
  SalaDeJuegoConnectionHandler: TSalaDeJuegoConnection;
  (*
  ds: TDataStore;

  dt: TDataTableOfCosa;
  dc: TDataColumnOfCosa;
  dr: TDataRowOfCosa;

  frmChild : TEditorForm;
  i: Integer;
  *)
begin
  DTF:=TDifferencesTreeForm.Create(self);
  DTF.ShowModal();
  (*
  OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if OpenDialog.Execute then
  begin
    filename := OpenDialog.Filename;
    openDialog.Free;

    SalaDeJuegoConnectionHandler:=TSalaDeJuegoConnection.Create(filename);
    SalaDeJuegoConnectionHandler.CreateSalaDeJuegoDataStore('sala');

    TreeView:=nil;
    DTF:=TDifferencesTreeForm.Create(self);
    DTF.Print(ucosa.DATA_STORE,
              'dt_TSalaDeJuego',
              1001,
              TreeView
    );
    DTF.ShowModal();

  end;
  *)
  (*
  ds:=TDataStore.Create();

  dt:=TDataTableOfCosa.Create('testGrid');

  dt.AddDataColumn(TDataColumnOfCosa.Create('Aatta', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('BddRd', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CsRss', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('eeeeEEee', TDataTypeIntegerOfCosa));
  dt.AddDataColumn(TDataColumnOfCosa.Create('CtttttttT', TDataTypeIntegerOfCosa));

  dr:= TDataRowOfCosa.Create(dt);
  for i := 0 to dt.DataColumnListCount-1  do
    dr.AddDataCell(TDataCellOfCosa.Create(IntToStr(i)));

  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());
  dt.AddDataRow(dr.Clone());

  ds.AddDataTable(dt);

  frmChild:=TEditorForm.Create(ds, TSIUD.TSELECT, nil, 'sala');
  frmChild.ShowModal();
  *)
end;
(*
procedure TFormEditSimSEE.rb_desde_archivo_cfbinChange(Sender: TObject);
var
  DataTable: TDataTableOfCosa;
  DataRowId: Integer;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  sval: string;
begin
  DataTable:=self.DataSet.GetDataTableByName('dt_TSalaDeJuego');
  DataRowId:=DataTable.DataRowList[0]._RowId;

  DataColumn:=DataTable.GetDataColumnByName('usarArchivoParaInicializarFrameInicial');
  DataCell:=DataTable.DataRowList[0].DataCellList[DataColumn.Index];
  DataCell.sval:=BoolToStr(self.rb_desde_archivo_cfbin.Checked);

  p_desde_archivo_cfbin.Enabled:=self.rb_desde_archivo_cfbin.Checked;
end;
*)
procedure TFormEditSimSEE.tcActoresChange(Sender: TObject);
begin

end;

(*
procedure TFormEditSimSEE.TSalaDeJuego_engancharconsalaChange(Sender: TObject);
var
  DataTable: TDataTableOfCosa;
  DataRowId: Integer;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  sval: string;
begin
  //DataTable:=self.DataSet.GetDataTableByName('dt_TSalaDeJuego');
  //DataRowId:=DataTable.DataRowList[0]._RowId;
  //
  //DataColumn:=DataTable.GetDataColumnByName('engancharconsala');
  //DataCell:=DataTable.DataRowList[0].DataCellList[DataColumn.Index];
  //DataCell.sval:=BoolToStr(self.rb_enganchar_con_sala.Checked);
  //
  //if self.rb_enganchar_con_sala.Checked then
  //begin
  //  DataColumn:=DataTable.GetDataColumnByName('archivosala_paraenganches');
  //  DataCell:=DataTable.DataRowList[0].DataCellList[DataColumn.Index];
  //  DataCell.sval:=e_archivo_para_enganches.Text;
  //end
  //else
  //begin
  //  DataColumn:=DataTable.GetDataColumnByName('archivocf_paraenganches');
  //  DataCell:=DataTable.DataRowList[0].DataCellList[DataColumn.Index];
  //  DataCell.sval:=e_archivo_para_enganches.Text;
  //end;
end;
*)
procedure TFormEditSimSEE.TSalaDeJuego_usararchivoparainicializarframeinicialClick
  (Sender: TObject);
begin

end;

(*
procedure TFormEditSimSEE.rg_HorariaOMinutalClick(Sender: TObject);
begin
  if rg_HorariaOMinutal.ItemIndex = 0 then
  begin
    PCPasoDeTiempo.TabIndex:=0;
  end
  else
  begin
    PCPasoDeTiempo.TabIndex:=1;
  end;
end;
*)
function TFormEditSimSEE.AsignarEventosYCargarControlesEstandar: boolean;
var
  dt_TSalaDeJuego: TDataTableOfCosa;
  dr_TSalaDeJuego: TDataRowOfCosa;
  dt_TGlobs: TDataTableOfCosa;
  dr_TGlobs: TDataRowOfCosa;


  DataColumn:TDataColumnOfCosa;

  sval:string;

  ainteger:integer;
  adouble:Double;
  astring:string;
  aboolean:boolean;
  aarchiRef:TArchiRef;

  pval:pointer;



begin
  if inherited AsignarEventosYCargarControlesEstandar then
  begin
    dt_TSalaDeJuego:=self.DataSet.GetDataTableByName('dt_TSalaDeJuego');
    dr_TSalaDeJuego:=dt_TSalaDeJuego.DataRowList[0];

    dt_TGlobs:=self.DataSet.GetDataTableByName('dt_TGlobs');
    dr_TGlobs:=dt_TGlobs.DataRowList[0];


    dt_TSalaDeJuego.ReadDataCellTextValue(dr_TSalaDeJuego._RowId, 'engancharconsala', sval);
    if StrToBool(sval) then
    begin
      self.rb_enganchar_con_sala.Checked:=true;

      dt_TSalaDeJuego.ReadDataCellTextValue(dr_TSalaDeJuego._RowId, 'archivoSala_ParaEnganches', sval);
      e_archivo_para_enganches.Text:=sval;
    end
    else
    begin
      //self.rb_enganchar_con_cf.Checked:=true;

      dt_TSalaDeJuego.ReadDataCellTextValue(dr_TSalaDeJuego._RowId, 'archivoCF_ParaEnganches', sval);
      self.e_archivo_para_enganches.Text:=sval;
    end;


    // ts_Simulador
    ////////////////////////////////////////////////////////////////////////////



    // ts_Flucar
    ////////////////////////////////////////////////////////////////////////////

    (*
    dt_TSalaDeJuego.ReadDataCellTextValue(dr_TSalaDeJuego._RowId, 'usarIteradorFlucar', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TSalaDeJuego_usarIteradorFlucar.Checked:=aboolean;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'iteracion_flucar_archivo_flucar', sval);
    DataColumn.DataType.Eval(sval, @astring);
    self.TGlobs_iteracion_flucar_archivo_flucar.Text:=astring;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'iteracion_flucar_modificar_rendimiento', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TGlobs_iteracion_flucar_modificar_rendimiento.Checked:=aboolean;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'iteracion_flucar_modificar_capacidad', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TGlobs_iteracion_flucar_modificar_capacidad.Checked:=aboolean;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'iteracion_flucar_modificar_peaje', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TGlobs_iteracion_flucar_modificar_peaje.Checked:=aboolean;
    *)

    // ts_CO2
    ////////////////////////////////////////////////////////////////////////////

    (*
    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'calcular_emisionesco2', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TGlobs_factoremisiones_margenoperativotipo.ItemIndex:=aboolean;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'factoremisiones_margenoperativotipo', sval);
    DataColumn.DataType.Eval(sval, @ainteger);
    self.TGlobs_factoremisiones_margenoperativotipo.ItemIndex:=ainteger;

    dt_TGlobs.ReadDataCellTextValue(dr_TGlobs._RowId, 'FactorEmisiones_ProyectoEolicoSolar', sval);
    DataColumn.DataType.Eval(sval, @aboolean);
    self.TGlobs_FactorEmisiones_ProyectoEolicoSolar.Checked:=aboolean;
    *)

  end;
end;

procedure TFormEditSimSEE.SetEvents();
begin
  self.TGlobs_usar_car.OnChange:=self.usar_car__OnChange;
  self.TGlobs_SortearOpt.OnChange:=self.SortearOpt__OnChange;
end;

procedure TFormEditSimSEE.usar_car__OnChange(Sender: TObject);
begin
  self.p_usar_car.Enabled:=self.TGlobs_usar_car.Checked;
end;

procedure TFormEditSimSEE.SortearOpt__OnChange(Sender: TObject);
begin
  self.TGlobs_ncronicasopt.Enabled:=self.TGlobs_SortearOpt.Checked;
end;

procedure TFormEditSimSEE.CargarControlesEspecificos;
begin

end;

constructor TFormEditSimSEE.Create(TheOwner: TComponent);
begin

  inherited Create(TheOwner);

  self.IgnoranceList:=TFPStringHashTable.Create();

  IgnoreTable:='dt_TSalaDeJuego';
  IgnoreList :='capa,'+
               'nombre,'+
               'descripcion,'+
               'globs,'+
               'gens,'+
               'dems,'+
               'sums,'+
               'nods,'+
               'arcs,'+
               'comerciointernacional,'+
               'usosgestionables,'+
               'listafuentes,'+
               //'estabilizarinicio,'+
               'randseed_sincronizaraliniciodecadacronica,'+
               //'usararchivoparainicializarframeinicial,'+
               'archivocf_paraenganches,'+
               'archivosala_paraenganches,'+
               'engancharconsala,'+
               'engancharconsala_escenario,'+
               //'archivocfaux,'+
               'enganchescontinuos,'+
               'enganchesdiscretos,'+
               //'enganchar_promediando_desaparecidas,'+
               //'uniformizar_promediando,'+
               'combustibles,'+
               //'usariteradorflucar,'+
               'generarraws,'+
               'plantillassimres3,'+
               'escenarios,'+
               'escenarioactivo';
  self.IgnoranceList.Add(IgnoreTable,IgnoreList);

  IgnoreTable:='dt_TGlobs';
  IgnoreList :='capa,'+
               'nombre,'+
               //'Calcular_EmisionesCO2,'+
               //'CAR,'+
               //'CAR_CVaR,'+
               //'Deterministico,'+
               'FactorEmisiones_MargenOperativoTipo,'+ // Se manipula específicamente...
               //'FactorEmisiones_ProyectoEolicoSolar,'+
               //'iteracion_flucar_Archivo_Flucar,'+
               //'iteracion_flucar_modificar_peaje,'+
               //'iteracion_flucar_modificar_rendimiento,'+
               //'iteracion_flucar_modificar_capacidad,'+
               //'NCronicasOpt,'+
               //'NCronicasSim,'+
               //'NDiscHistoCF,'+
               //'NMAX_ITERACIONESDELPASO_OPT,'+
               //'NMAX_ITERACIONESDELPASO_SIM,'+
               //'ObligarDisponibilidad_1_Opt,'+
               //'ObligarDisponibilidad_1_Sim,'+
               //'ObligarInicioCronicaIncierto_1_Sim,'+
               //'probLimiteRiesgo,'+
               //'publicarSoloVariablesUsadasEnSimRes3,'+
               //'restarUtilidadesDelCostoFuturo,'+
               //'semilla_inicial_opt,'+
               //'semilla_inicial_sim,'+
               //'SortearOpt,'+
               //'TasaDeActualizacion,'+
               //'usar_CAR,'+
               //Ignoro SalaMinutal ya que se carga como control especifico
               'SalaMinutal';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListGenerador';
   IgnoreList :='capa,'+
                'nombre,'+
                'n';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListFuenteAleatoria';
   IgnoreList :='n';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

   IgnoreTable:='dt_TListaEscenarios';
   IgnoreList :='capa,'+
                'nombre,'+
                'n';
   self.IgnoranceList.Add(IgnoreTable,IgnoreList);

end;

procedure TFormEditSimSEE.QueryInical;
var
  sval:string;
  split:TStringList;
  DataTableName: String;
  DataRowId: Integer;
begin
  self.DataSet:=TDataStore.Create(DATA_STORE);

  if self.DataSet.Query('*', 'dt_TSalaDeJuego', 1001, self.dataSet) then
  begin

    //GLOBS:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'globs', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE FUENTES:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'listaFuentes', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE ESCENARIOS:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'Escenarios', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

    //LISTA DE ACTORES:
    self.dataSet.ReadDataCellTextValue('dt_TSalaDeJuego', 1001, 'gens', sval);
    split:=TStringList.Create();
    ExtractStrings(['.'], [], PChar(sval), split);
    DataTableName:= split[0];
    DataRowId:= StrToInt(split[1]);
    split.Free;
    self.DataSet.Query('*', DataTableName, DataRowId, self.dataSet);

  end
  else
  begin
    //Ver cuando la sala en nueva.......
  end;

end;


end.

